c=======================================================================
c  This source code is public domain, and may be freely distributed,
c  modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO
c  WARRANTY OF ANY KIND.
c=======================================================================
c   merload.f -- load a Merlin pool into memory
c=======================================================================
      program merload
      include 'dt_f_smiles.inc'
      include 'dt_f_datatype.inc'
      include 'dt_f_merlin.inc'
c-----------------------------------------------------------------------
      integer    server_h, db_h
      integer    hostlen, dblen, isnew
      character*(100) host, db
      logical ok
c-----------------------------------------------------------------------
c  Declare functions used
c-----------------------------------------------------------------------
      integer dt_f_mer_server, dt_f_open
      logical dt_f_isopen, dt_f_hold, dt_f_isheld
c-----------------------------------------------------------------------
c  Input host and database
c-----------------------------------------------------------------------
4     continue
      print '(/A$)', 'Enter hostname: '
      read (*, fmt='(Q,A)', err=4) hostlen, host
      server_h = dt_f_mer_server(host(:hostlen), 'merlin', 'thor',
     &                           ' ',isnew)
      if (NULL_OB .eq. server_h) then
        print *, 'Failed to connect to host: ', host(:hostlen)
        go to 1000
      endif
      print *, 'Connected to host: ', host(:hostlen)
5     continue
      print '(/A$)', 'Enter database: '
      read (*, fmt='(Q,A)', err=5) dblen, db
      ok = dt_f_isopen(server_h, db(:dblen))
      if (ok) then
        print *, 'Pool already open...'
      else
        print *, 'Loading pool...'
      endif
      db_h =dt_f_open(server_h, db(:dblen), 'r', ' ', isnew)
      if (NULL_OB .eq. db_h) then
        print *, 'Failed to load pool...'
        go to 1000
      end if
      ok = dt_f_isheld(db_h)
      if (ok) then
        print *, 'Pool already held...'
      else
        ok = dt_f_hold(db_h, ' ')
        if (.not.ok) then
          print *, 'Couldn''t hold pool...'
        else
          print *, 'Pool held in memory...'
        endif
      endif
      print *, 'Loaded and held pool: ', db(:dblen)
c-----------------------------------------------------------------------
c  Drop here to exit program
c-----------------------------------------------------------------------
1000  continue
      print *, 'So long, baby!'
      end
