c======================================================================
c  This source code is public domain, and may be freely distributed,
c  modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO
c  WARRANTY OF ANY KIND.
c======================================================================
c  verbosetalk.f - demo program write to/from pipes
c----------------------------------------------------------------------
      program verbosetalk
      include 'dt_f_smiles.inc'
      include 'dt_f_progob.inc'
c----------------------------------------------------------------------
c  Declarations - note that in fortran, handles are integers
c----------------------------------------------------------------------
      external mytalk
      integer hello
c----------------------------------------------------------------------
      call my_welcome(hello)
      call du_f_pipe_loop(hello, mytalk)
      print *, 'So long, baby!'
      end
c======================================================================
c  Subroutine my_welcome()
c----------------------------------------------------------------------
      subroutine my_welcome(hello)
      integer hello
      include 'dt_f_smiles.inc'
      include 'dt_f_progob.inc'
c----------------------------------------------------------------------
      character*(80) buff
      logical ok
c----------------------------------------------------------------------
c  Declare functions used.
c----------------------------------------------------------------------
      integer getpid
      integer dt_f_alloc_seq, dt_f_alloc_string
      logical dt_f_append
c     integer getppid
c----------------------------------------------------------------------
      hello = dt_f_alloc_seq()
      buff = 'child welcome:  pid '
      buff(31:) = ', ppid '
      write (buff(21:), '(I10)') getpid()
c     write (buff(38:), '(I10)') getppid()
      ok = dt_f_append(hello, dt_f_alloc_string(buff(:47)))
      end
c======================================================================
c  Subroutine mytalk()
c----------------------------------------------------------------------
      subroutine mytalk(msgin, msgout)
      integer msgin, msgout
      include 'dt_f_smiles.inc'
      include 'dt_f_progob.inc'
c----------------------------------------------------------------------
      integer msg, nin, bin, lens
      integer sob
      INTEGER DM_PIPEBUF
      PARAMETER ( DM_PIPEBUF = 4000 )
      character*(DM_PIPEBUF) buff
      character*(DM_PIPEBUF) str
      logical ok
c----------------------------------------------------------------------
c  Declare functions used.
c----------------------------------------------------------------------
      integer dt_f_next, dt_f_alloc_string, dt_f_alloc_seq
      integer dt_f_stringvalue
      logical dt_f_append, dt_f_reset
      integer help, program, version, notice
c----------------------------------------------------------------------
      if (msgin .eq. NULL_OB) then
        msgout = dt_f_alloc_seq()
        write (buff, '(A,I10,A)') 'child farewell: ', bin, ' byte(s), '
        write (buff(37:), '(I10,A)') nin, ' line(s), '
        write (buff(58:), '(I10,A)') msg, ' message(s)'
        ok = dt_f_append(msgout, dt_f_alloc_string(buff(:78)))
        ok = dt_f_reset(msgout)
        return
      endif
c----------------------------------------------------------------------
      msgout = dt_f_alloc_seq()
      msg = msg + 1
      ok = dt_f_reset(msgin)
10    continue
        sob = dt_f_next(msgin)
        if (sob .eq. NULL_OB) go to 100
        lens = dt_f_stringvalue(sob, str)
        if (str(:lens) .eq. DX_PT_HELP) then
          call app2seq(msgout, help())
        else if (str(:lens) .eq. DX_PT_PROGRAM) then
          call app2seq(msgout, program())
        else if (str(:lens) .eq. DX_PT_VERSION) then
          call app2seq(msgout, version())
        else if (str(:lens) .eq. DX_PT_NOTICE) then
          call app2seq(msgout, notice())
        else if (str(:lens) .eq. DX_PT_MSGLIST) then
          continue
        else
          write (buff, '(A,A,A,I10)')
     &           'child received "', str(:lens), '"', lens
          ok = dt_f_append(msgout,
     &           dt_f_alloc_string(buff(:(27 + lens))))
          bin = bin + lens
          nin = nin + 1
        endif
      go to 10
100   continue
        ok = dt_f_reset(msgout)
      end
c======================================================================
c  Subroutine app2seq()
c----------------------------------------------------------------------
      subroutine app2seq(sos, newsos)
      integer sos, newsos
      logical ok
      include 'dt_f_smiles.inc'
      include 'dt_f_progob.inc'
c----------------------------------------------------------------------
      integer sob
c----------------------------------------------------------------------
c  Declare functions used.
c----------------------------------------------------------------------
      integer dt_f_next
      logical dt_f_append, dt_f_reset
c----------------------------------------------------------------------
      ok = dt_f_reset(newsos)
10    continue
        sob = dt_f_next(newsos)
        if (sob .eq. NULL_OB) go to 100
        ok = dt_f_append(sos, sob)
      go to 10
100   continue
      end
c======================================================================
c  Function help()
c----------------------------------------------------------------------
      integer function help()
      include 'dt_f_smiles.inc'
      include 'dt_f_progob.inc'
c----------------------------------------------------------------------
      integer sos
      logical ok
c----------------------------------------------------------------------
c  Declare functions used.
c----------------------------------------------------------------------
      integer dt_f_alloc_seq, dt_f_alloc_string
      logical dt_f_append, dt_f_reset
c----------------------------------------------------------------------
      sos = dt_f_alloc_seq()
      ok = dt_f_append(sos,
     &  dt_f_alloc_string(
     &    'This program takes no options or arguments.'))
      ok = dt_f_append(sos,
     &  dt_f_alloc_string(
     &    'Typical usage: % pipetalker verbosetalk'))
      ok = dt_f_reset(sos)
      help = sos
      return
      end
c======================================================================
c  Function program()
c----------------------------------------------------------------------
      integer function program()
      include 'dt_f_smiles.inc'
      include 'dt_f_progob.inc'
c----------------------------------------------------------------------
      integer sos
      logical ok
c----------------------------------------------------------------------
c  Declare functions used.
c----------------------------------------------------------------------
      integer dt_f_alloc_seq, dt_f_alloc_string
      logical dt_f_append, dt_f_reset
c----------------------------------------------------------------------
      sos = dt_f_alloc_seq()
      ok = dt_f_append(sos, dt_f_alloc_string('verbosetalk 4.41.'))
      ok = dt_f_reset(sos)
      program = sos
      return
      end
c======================================================================
c  Function version()
c----------------------------------------------------------------------
      integer function version()
      include 'dt_f_smiles.inc'
      include 'dt_f_progob.inc'
c----------------------------------------------------------------------
      integer sos
      logical ok
c----------------------------------------------------------------------
c  Declare functions used.
c----------------------------------------------------------------------
      integer dt_f_alloc_seq, dt_f_alloc_string
      logical dt_f_append, dt_f_reset
c----------------------------------------------------------------------
      sos = dt_f_alloc_seq()
      ok = dt_f_append(sos, dt_f_alloc_string('441'))
      ok = dt_f_reset(sos)
      version = sos
      return
      end
c======================================================================
c  Function notice()
c----------------------------------------------------------------------
      integer function notice()
      include 'dt_f_smiles.inc'
      include 'dt_f_progob.inc'
c----------------------------------------------------------------------
      integer sos
      logical ok
c----------------------------------------------------------------------
c  Declare functions used.
c----------------------------------------------------------------------
      integer dt_f_alloc_seq, dt_f_alloc_string
      logical dt_f_append, dt_f_reset
c----------------------------------------------------------------------
      sos = dt_f_alloc_seq()
      ok = dt_f_append(sos,
     &  dt_f_alloc_string(
     &    'pipetalker 1994 (c) Daylight CIS, Inc.'))
      ok = dt_f_append(sos,
     &  dt_f_alloc_string(
     &    'pipetalker may be freely distributed'))
      ok = dt_f_reset(sos)
      notice = sos
      return
      end
