c======================================================================
c  This source code is public domain, and may be freely distributed,
c  modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO
c  WARRANTY OF ANY KIND.
c======================================================================
c   look4.f -- look for a SMARTS in a list of SMILES
c======================================================================
      program look4
      include 'dt_f_smiles.inc'
      include 'dt_f_smarts.inc'
c----------------------------------------------------------------------
      integer    MAXSMI
      parameter (MAXSMI = 2000)
      integer    mol, pathset, pattern
      character*(MAXSMI) smiles, smarts
      integer    smi_in, smi_out, leninfile, ilun, lensmiles, lensmarts
      character*(100) infile
      logical    ok
c----------------------------------------------------------------------
c  Declare functions used
c----------------------------------------------------------------------
      integer dt_f_smilin, dt_f_smartin, dt_f_match
      logical dt_f_dealloc
c----------------------------------------------------------------------
c  Input and interpret SMARTS
c----------------------------------------------------------------------
5     continue
      print '(/A$)', 'Enter SMARTS: '
      read (*, fmt='(Q,A)', err=5) lensmarts, smarts
      pattern = dt_f_smartin(smarts(:lensmarts))
      if (pattern .eq. NULL_OB) then
        print *, 'SMARTS rejected...'
        go to 5
      end if
c----------------------------------------------------------------------
c  Open input SMILES file
c----------------------------------------------------------------------
10    continue
      print '(/A$)', 'Input SMILES file: '
      read (*, fmt='(Q,A)', err=10) leninfile, infile
      open (unit=ilun, file=infile(:leninfile), status='old',
     &      access='sequential', err=999)
c----------------------------------------------------------------------
c  Main loop
c----------------------------------------------------------------------
      smi_in = 0
      smi_out = 0
20    continue
      read ( unit=ilun, fmt='(Q,A)', end=1000) lensmiles, smiles
      smi_in = smi_in + 1
c----------------------------------------------------------------------
c  Interpret SMILES
c----------------------------------------------------------------------
      mol = dt_f_smilin(smiles(:lensmiles))
      if (mol .eq. NULL_OB) then
        print *, 'SMILES rejected...'
c----------------------------------------------------------------------
c  If SMARTS in SMILES, print line (SMILES and name)
c----------------------------------------------------------------------
      else 
        pathset = dt_f_match(pattern, mol, 0)
        if (pathset .eq. NULL_OB) then
          continue
        else
          print *, smiles(:lensmiles)
          smi_out = smi_out + 1
        end if
      end if
      ok = dt_f_dealloc(mol)
100   go to 20
c----------------------------------------------------------------------
c  Drop here to exit program
c----------------------------------------------------------------------
999   print *, 'ERROR (LOOK4) Can''t open input file...'
1000  continue
      print *, 'SMILES in: ', smi_in
      print *, 'SMILES out: ', smi_out
      end
