c======================================================================
c  This source code is public domain, and may be freely distributed,
c  modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO
c  WARRANTY OF ANY KIND.
c======================================================================
c  protons.f - Counts the number of protons in a molecule  
c----------------------------------------------------------------------
      program  protons
      include 'dt_f_smiles.inc'
c----------------------------------------------------------------------
c  SMILES length limit is set here - the Toolkit doesn't impose one.
c----------------------------------------------------------------------
      integer maxsmi
      parameter ( maxsmi = 2000 )
c----------------------------------------------------------------------
c  Declarations - note that in fortran, handles are integers
c----------------------------------------------------------------------
      integer            mol, atoms, atom
      integer            lensmi, lenmsg, pcount
      character*(maxsmi) smi,    msg
      logical            ok
c----------------------------------------------------------------------
c  Declare functions used.
c----------------------------------------------------------------------
      integer dt_f_smilin, dt_f_smilinerrtext, dt_f_stream, dt_f_next
      integer dt_f_number, dt_f_hcount
      logical dt_f_dealloc
c----------------------------------------------------------------------
c  Loop over input
c----------------------------------------------------------------------
10    continue
         pcount = 0
         print '(/A$)', 'Enter SMILES ..... '
         read (*, '(Q,A)', END=999) lensmi, smi
c----------------------------------------------------------------------
c  Create molecule by interpreting SMILES; print any warnings.
c----------------------------------------------------------------------
         mol    = dt_f_smilin(smi(:lensmi))
         if (mol .eq. NULL_OB) print *, 'Uninterpretable SMILES'
         lenmsg = dt_f_smilinerrtext(msg)
         if (lenmsg .gt. 0)    print *, msg(:lenmsg)
c----------------------------------------------------------------------
c  Loop over atoms; for each atom add atomic# to H-count
c----------------------------------------------------------------------
         atoms = dt_f_stream(mol, TYP_ATOM)
20       continue
         atom = dt_f_next(atoms)
         if (atom .eq. NULL_OB) go to 100
         pcount = pcount + dt_f_number(atom) + dt_f_hcount(atom)
         go to 20
100      continue
c----------------------------------------------------------------------
c  Deallocate molecule before looping back for next.
c  Note that if DT_F_DEALLOC(NULL_OB) is not an error, just a no-op.
c----------------------------------------------------------------------
	 ok = dt_f_dealloc(mol)
         print *, 'Proton count: ', pcount
      go to 10
c----------------------------------------------------------------------
c  Drop out of loop on EOF.
c----------------------------------------------------------------------
999   continue
      print *, 'So long, baby!'
      end
