c======================================================================
c  This source code is public domain, and may be freely distributed,
c  modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO
c  WARRANTY OF ANY KIND.
c======================================================================
c  SHOWMF.F - Prints the standardized molecular formula (datatype F)
c----------------------------------------------------------------------
      program  showmf
      include 'dt_f_smiles.inc'
c----------------------------------------------------------------------
c  Define parameters
c----------------------------------------------------------------------
      integer MAXSMI
      parameter ( MAXSMI = 2000 )
      integer MAXMF
      parameter ( MAXMF = 512 )
c----------------------------------------------------------------------
c  Declare handle variables
c----------------------------------------------------------------------
      integer mol
c----------------------------------------------------------------------
c  Declare other variables
c----------------------------------------------------------------------
      integer            lensmi, lenmsg, mflen
      character*(MAXSMI) smi, msg
      character*(MAXMF)  mf
      logical            ok
c----------------------------------------------------------------------
c  Declare functions used.
c----------------------------------------------------------------------
      integer dt_f_smilin, dt_f_smilinerrtext
      logical dt_f_dealloc
c----------------------------------------------------------------------
c  Loop over input
c----------------------------------------------------------------------
10    continue
         print '(/A$)', 'Enter SMILES: '
         read (*, '(Q,A)', end=999) lensmi, smi
c----------------------------------------------------------------------
c  Create molecule by interpreting SMILES; print any warnings.
c----------------------------------------------------------------------
         mol    = dt_f_smilin(smi(:lensmi))
         if (mol .eq. NULL_OB) print *, 'Uninterpretable SMILES'
         lenmsg = dt_f_smilinerrtext(msg)
         if (lenmsg .gt. 0)   print *, msg(:lenmsg)
c----------------------------------------------------------------------
c  Print MF if computable.
c----------------------------------------------------------------------
         mf = ''
         call du_mf(mol, mf, mflen)
         if (mf .eq. '') then
            print *, 'MF is not computable...'
         else
            print *, 'MF = ', mf(:mflen)
         endif
c----------------------------------------------------------------------
c  Deallocate molecule before looping back for next.
c  Note that if DT_F_DEALLOC(NULL_OB) is not an error, just a no-op.
c----------------------------------------------------------------------
	 ok = dt_f_dealloc(mol)
      go to 10
c----------------------------------------------------------------------
c  Drop out of loop on EOF.
c----------------------------------------------------------------------
999   continue
      print *, 'So long, baby!'
      end
