c=======================================================================
c  This source code is public domain, and may be freely distributed,
c  modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO
c  WARRANTY OF ANY KIND.
c=======================================================================
c   thorirefs.f -- print all indirect refs from a database
c=======================================================================
      program thorirefs
      include 'dt_f_smiles.inc'
      include 'dt_f_datatype.inc'
      include 'dt_f_thor.inc'
c-----------------------------------------------------------------------
      integer    server_h, db_h, tdt_h, tdt_stream, subtdt_stream
      integer    subtdt_h
      integer    hostlen, dblen, tdtcount, isnew, ofilelen, olun
      integer    irefcount
      character*(100) host, db, ofile
      logical    ok
      common /thorirefs_global/ olun, irefcount
c-----------------------------------------------------------------------
c  Declare functions used
c-----------------------------------------------------------------------
      integer dt_f_thor_server, dt_f_open, dt_f_stream, dt_f_next
      logical dt_f_dealloc
c-----------------------------------------------------------------------
c  Print banner
c-----------------------------------------------------------------------
      print *, '     *********************************************'
      print *, '     | thorirefs - prints db irefs to TDT file   |'
      print *, '     *********************************************'
      print *, '     |            Daylight CIS, Inc.             |'
      print *, '     |      Toolkit Demonstration Program        |'
      print *, '     *********************************************'
c-----------------------------------------------------------------------
c  Input host and database
c-----------------------------------------------------------------------
5     continue
      print '(/A$)', 'Enter hostname: '
      read (*, fmt='(Q,A)', err=5) hostlen, host
      server_h = dt_f_thor_server(host(:hostlen), 'thor', 'thor',
     &                            ' ',isnew)
10    continue
      print '(/A$)', 'Enter database: '
      read (*, fmt='(Q,A)', err=10) dblen, db
      db_h =dt_f_open(server_h, db(:dblen), 'r', ' ', isnew)
      if ((NULL_OB .eq. server_h) .or. (NULL_OB .eq. db_h)) then
        print *, 'Failed to open database...'
        go to 1000
      end if
      print *, 'Connected to host ', host(:hostlen)
      print *, 'Opened database ', db(:dblen)
c-----------------------------------------------------------------------
c  Get output filename
c-----------------------------------------------------------------------
20    continue
      print '(/A$)', 'Enter output filename: '
      read (*, fmt='(Q,A)', err=20) ofilelen, ofile
      open (unit=olun, file=ofile(:ofilelen), status='new',
     &      access='sequential', err=20)
c-----------------------------------------------------------------------
c  Stream TDTs, subTDTs; call du_tdt2irefs to look for irefs.
c-----------------------------------------------------------------------
      tdt_stream = dt_f_stream(db_h, TYP_DATATREE)
      tdtcount = 0
60    continue
      tdt_h = dt_f_next(tdt_stream)
      if (tdt_h .eq. NULL_OB) go to 200
      tdtcount = tdtcount + 1
      call du_tdt2irefs(tdt_h)
      subtdt_stream = dt_f_stream(tdt_h, TYP_DATATREE)
70    continue
      subtdt_h = dt_f_next(subtdt_stream)
      if (subtdt_h .eq. NULL_OB) go to 100
      call du_tdt2irefs(subtdt_h)
      go to 70
100   continue
      ok = dt_f_dealloc(tdt_h)
      go to 60
200   continue
c-----------------------------------------------------------------------
c  Drop here to exit program
c-----------------------------------------------------------------------
1000  continue
      print *, 'TDTs read:   ', tdtcount
      print *, 'Irefs found: ', irefcount
      end
c=======================================================================
c  du_tdt2irefs - find all indirect datafields in a tdt
c=======================================================================
      subroutine du_tdt2irefs(tdt_h)
      include 'dt_f_smiles.inc'
      include 'dt_f_datatype.inc'
      include 'dt_f_thor.inc'
c-----------------------------------------------------------------------
      integer    tdt_h, ditem_stream, ditem_h, dfield_stream, dfield_h
      integer    taglen, fieldlen
      character*(100) tag, field
      logical    ok
c-----------------------------------------------------------------------
c  Declare functions used
c-----------------------------------------------------------------------
      integer dt_f_stream, dt_f_next, dt_f_dfnormdata
      integer dt_f_thor_raw_datafield
      logical dt_f_dfnorm
c-----------------------------------------------------------------------
c  Stream data items and data fields; check if indirect.
c-----------------------------------------------------------------------
      ditem_stream = dt_f_stream(tdt_h, TYP_DATAITEM)
10    continue
      ditem_h = dt_f_next(ditem_stream)
      if (ditem_h .eq. NULL_OB) go to 100
      dfield_stream = dt_f_stream(ditem_h, TYP_DATAFIELD)
20    continue
      dfield_h = dt_f_next(dfield_stream)
      if (dfield_h .eq. NULL_OB) go to 10
      ok = dt_f_dfnorm(dfield_h, DX_THOR_INDIRECT)
      if (ok) then
        taglen = dt_f_dfnormdata(dfield_h, DX_THOR_INDIRECT, tag)
        fieldlen = dt_f_thor_raw_datafield(dfield_h, field)
        call du_field2subfields(tag, taglen, field, fieldlen)
      endif
      go to 20
100   continue
      end
c=======================================================================
c  du_field2subfields - Since indirect fields can consist of several    
c                       subfields, each an indirect reference, we 
c                       separate and print subfields separately.
c=======================================================================
      subroutine du_field2subfields(tag, taglen, field, fieldlen)
      include 'dt_f_smiles.inc'
      include 'dt_f_datatype.inc'
      include 'dt_f_thor.inc'
c-----------------------------------------------------------------------
      integer    taglen, fieldlen, subfieldlen, i, j, olun, irefcount
      character*(100)  tag, field
      character*(1000) buff
      common /thorirefs_global/ olun, irefcount
c-----------------------------------------------------------------------
      buff(:taglen+1) = tag(:taglen) // '<'
      i = 1
10    continue
      if (i .gt. fieldlen) go to 100
      j = index(field(i:fieldlen), '~')
      if (j .eq. 0) then
        subfieldlen = fieldlen - i + 1
      else
        subfieldlen = j - 1
      endif
      if (subfieldlen .gt. 0) then
        buff(taglen+2:) = field(i:i+subfieldlen-1)
        buff(taglen+1+subfieldlen+1:) = '>|'
        write (olun, '(A)') buff(:taglen+1+subfieldlen+2)
        irefcount = irefcount + 1
      endif
      i = i + subfieldlen + 1
      go to 10
100   continue
c-----------------------------------------------------------------------
      return
      end
