c=======================================================================
c  This source code is public domain, and may be freely distributed,
c  modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO
c  WARRANTY OF ANY KIND.
c=======================================================================
c   thorlist.f -- dump a Thor database
c=======================================================================
      program thorlist
      include 'dt_f_smiles.inc'
      include 'dt_f_datatype.inc'
      include 'dt_f_thor.inc'
c-----------------------------------------------------------------------
      integer    server_h, db_h, tdt_h, tdt_stream
      integer    hostlen, dblen, count, isnew, tdtlen, ofilelen, olun
      character*(100) host, db, ofile
      character*(4000) tdt
      logical ok
c-----------------------------------------------------------------------
c  Declare functions used
c-----------------------------------------------------------------------
      integer dt_f_thor_server, dt_f_open, dt_f_stream, dt_f_next
      integer dt_f_thor_tdt2str
      logical dt_f_dealloc
c-----------------------------------------------------------------------
c  Input host and database
c-----------------------------------------------------------------------
5     continue
      print '(/A$)', 'Enter hostname: '
      read (*, fmt='(Q,A)', err=5) hostlen, host
      server_h = dt_f_thor_server(host(:hostlen), 'thor', 'thor',
     &                            ' ',isnew)
10    continue
      print '(/A$)', 'Enter database: '
      read (*, fmt='(Q,A)', err=10) dblen, db
      db_h =dt_f_open(server_h, db(:dblen), 'r', ' ', isnew)
      if ((NULL_OB .eq. server_h) .or. (NULL_OB .eq. db_h)) then
        print *, 'Failed to open database...'
        go to 1000
      end if
      print *, 'Connected to host ', host(:hostlen)
      print *, 'Opened database ', db(:dblen)
c-----------------------------------------------------------------------
c  Get output filename
c-----------------------------------------------------------------------
20    continue
      print '(/A$)', 'Enter output filename: '
      read (*, fmt='(Q,A)', err=20) ofilelen, ofile
      open (unit=olun, file=ofile(:ofilelen), status='new',
     &      access='sequential', err=20)
c-----------------------------------------------------------------------
c  Stream TDTs over database.  
c-----------------------------------------------------------------------
      tdt_stream = dt_f_stream(db_h, TYP_DATATREE)
      count = 0
c-----------------------------------------------------------------------
c  Main loop
c-----------------------------------------------------------------------
      print *, 'Listing database to file...'
30    continue
      tdt_h = dt_f_next(tdt_stream)
      if (NULL_OB .eq. tdt_h) go to 1000
      tdtlen = dt_f_thor_tdt2str(tdt_h, .false., tdt)
      write (olun, '(A)') tdt(:tdtlen)
      count = count + 1
      ok = dt_f_dealloc(tdt_h)
100   go to 30
c-----------------------------------------------------------------------
c  Drop here to exit program
c-----------------------------------------------------------------------
1000  continue
      print *, 'TDTs out: ', count
      end
